//------------------------------------------------------------------------------
// Theta-tiltShift  version 0.1  by E.Kako @kako.com (c)2013
//------------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "opencv2/opencv.hpp"

// gamma adjust ... http://imagingsolution.blog107.fc2.com/blog-entry-166.html
void cv_Gamma(IplImage* src, IplImage* dst, double gamma)
{
	int i;
	uchar LUT[256];
	for (i = 0; i < 256; i++){  
		LUT[i]=(int)(pow((double)i/255.0,1.0/gamma)*255.0);
	}
	CvMat lut_mat = cvMat(1, 256, CV_8UC1, LUT);
	cvLUT(src, dst, &lut_mat);
} 

//------------------------------------------------------------------------------
// Main program
//------------------------------------------------------------------------------
int main(int argc,char **argv)
{
	IplImage *image,*image1,*image2,*image3,*image4,*image5,*mask;
	int wd,ht;
	char fname[1024];

	printf("<<< theta-tiltshift  version 0.1  by E.kako @kako.com >>>\n");

	if (argc!=2) {
		printf("Usage: theta-tiltshift filename\n"); return 0;
	}

	strcpy(fname,argv[1]);
	// load imagefile
	image = cvLoadImage(fname,CV_LOAD_IMAGE_ANYCOLOR);
	if (image == NULL) {
		printf("Error: cannot load image file.\n"); return 1;
	}
	
	// image size
	wd = image->width; ht = image->height;

	// image memory
	image1 = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);
	image2 = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);
	image3 = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);
	image4 = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);
	image5 = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);
	mask = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);

	// ڂ摜̍쐬 gaussian
	cvSmooth(image, image1, CV_GAUSSIAN, 5, 0, 0, 0);
	cvSmooth(image, image2, CV_GAUSSIAN, 13, 0, 0, 0);
	cvSmooth(image, image3, CV_GAUSSIAN, 21, 0, 0, 0);
	cvSmooth(image, image4, CV_GAUSSIAN, 27, 0, 0, 0);
	cvSmooth(image, image5, CV_GAUSSIAN, 31, 0, 0, 0);
	
	// 摜̍ conbine
	cvSet(mask, cvScalarAll(0), 0 );
	cvRectangle(mask,cvPoint(0,0),cvPoint(wd,ht/10*3),cvScalarAll(255),CV_FILLED,8,0);
	cvCopy(image5, image, mask);
	cvSet(mask, cvScalarAll(0), 0 );
	cvRectangle(mask,cvPoint(0,ht/10*3),cvPoint(wd,ht/10*4),cvScalarAll(255),CV_FILLED,8,0);
	cvCopy(image4, image, mask);
	cvSet(mask, cvScalarAll(0), 0 );
	cvRectangle(mask,cvPoint(0,ht/10*4),cvPoint(wd,ht/10*5),cvScalarAll(255),CV_FILLED,8,0);
	cvCopy(image3, image, mask);
	cvSet(mask, cvScalarAll(0), 0 );
	cvRectangle(mask,cvPoint(0,ht/10*5),cvPoint(wd,ht/10*6),cvScalarAll(255),CV_FILLED,8,0);
	cvCopy(image2, image, mask);
	cvSet(mask, cvScalarAll(0), 0 );
	cvRectangle(mask,cvPoint(0,ht/10*6),cvPoint(wd,ht/10*7),cvScalarAll(255),CV_FILLED,8,0);
	cvCopy(image1, image, mask);
	cvSet(mask, cvScalarAll(0), 0 );
	cvRectangle(mask,cvPoint(0,ht/10*8.5),cvPoint(wd,ht/10*9.5),cvScalarAll(255),CV_FILLED,8,0);
	cvCopy(image1, image, mask);
	cvSet(mask, cvScalarAll(0), 0 );
	cvRectangle(mask,cvPoint(0,ht/10*9.5),cvPoint(wd,ht),cvScalarAll(255),CV_FILLED,8,0);
	cvCopy(image2, image, mask);

	// K}␳ ... ̖邢̓RgXgキAȊO̓RgXgȂ͂
	cv_Gamma(image, image1, 0.8);	

	// save image file
	strcat(fname,".tiltshift.jpg");
	cvSaveImage(fname, image1);
	printf("generated image(%s).\n",fname);
	
	// release memory
	cvReleaseImage(&image);
	cvReleaseImage(&image1);
	cvReleaseImage(&image2);
	cvReleaseImage(&image3);
	cvReleaseImage(&image4);
	cvReleaseImage(&image5);
	cvReleaseImage(&mask);

	return 0;
}
